local gr, li, ky, tm	= love.graphics, love.image, love.keyboard, love.timer
local pi, sin, cos, atan2 = math.pi, math.sin, math.cos, math.atan2
local sqrt, abs, min, max = math.sqrt, math.abs, math.min, math.max
function love.load()
	gr.setCaption( 'Shortest Distance between Point & Line' )
	gr.setBackgroundColor( 5, 5, 5, 255 )
	wd, ht			= 500, 500
	gr.setMode(wd,ht,{})
	l1, l2, l3, l4	= { 100, 100 }, {}, {}, {}
	pt				= { 300, 300 }
	an = 0
	end

function love.update(dt)
	an=an+dt
	l2[1] = 200 * sin( an ) + l1[1]
	l2[2] = 200 * cos( an ) + l1[2]
	l3[1] = 350 * sin( an ) + l1[1]
	l3[2] = 350 * cos( an ) + l1[2]
	l4[1] = 350 * sin( an+pi ) + l1[1]
	l4[2] = 350 * cos( an+pi ) + l1[2]
	d=distPointToLine( pt, l1, l2 )
	d2=distPointToLineSegment( pt, l1, l2 )
	x3,y3=closestPointOnLine( pt, l1, l2 )
	x4,y4 = closestPointOnLineSegment( pt, l1, l2 )
	end

function love.draw()
	gr.setLineWidth(2)
	gr.setColor( 255, 255, 0, 255 )
	gr.line( l1[1], l1[2], l2[1], l2[2] )
	gr.print( 'line segment', 10, 20 )
	gr.setColor( 85, 85, 200 )
	gr.line( l2[1], l2[2], l3[1], l3[2] )
	gr.line( l1[1], l1[2], l4[1], l4[2] )
	gr.print( 'line extention', 10, 40 )
	gr.setColor( 255, 255, 255 )
	gr.circle( 'fill', pt[1], pt[2], 6 )
	gr.print( 'point', 10, 60 )
	gr.setColor( 0, 255, 0 )
	gr.circle( 'line', pt[1], pt[2], d )
	gr.print( 'closest distance to line', 10, 80 )
	gr.setColor( 255, 0, 0 )
	gr.circle( 'line', pt[1], pt[2], d2 )
	gr.print( 'closest distance to line segment', 10, 100 )
	gr.setColor( 0, 255, 255 )
	gr.circle( 'line', x3, y3, 6 )
	gr.line( pt[1], pt[2], x3, y3 )
	gr.print( 'closest point on line', 10, 120 )
	gr.setColor( 255, 0, 255 )
	gr.circle( 'fill', x4, y4, 5 )
	gr.line( pt[1], pt[2], x4, y4 )
	gr.print( 'closest point on line segment', 10, 140 )
	end

function love.keypressed(key)
	if key == 'escape'	then love.event.quit() 	end
	end

function distPointToLine(pt,l1,l2)	-- not line segment
	local dx,dy = l2[1] - l1[1], l2[2] - l1[2]
	local length = math.sqrt( dx*dx + dy*dy )
	dx,dy = dx/length, dy/length
	return abs( dy*(pt[1]-l1[1]) - dx*(pt[2]-l1[2]))
	end

function distPointToLineSegment(pt,l1,l2)
	local dx,dy = l2[1]-l1[1],l2[2]-l1[2]
	local length = sqrt( dx*dx + dy*dy )
	dx,dy = dx/length,dy/length
	local posOnLine = dx*(pt[1]-l1[1]) + dy*(pt[2]-l1[2])
	if posOnLine < 0 then
		-- first end point is closest
		dx,dy = pt[1]-l1[1],pt[2]-l1[2]
		return sqrt(dx*dx+dy*dy)
		elseif posOnLine > length then
			-- second end point is closest
			dx,dy = pt[1]-l2[1],pt[2]-l2[2]
			return sqrt(dx*dx+dy*dy)
		else
			-- point is closest to some part in the middle of the line
			return abs( dy*(pt[1]-l1[1]) - dx*(pt[2]-l1[2]))
		end
	end

function closestPointOnLineSegment(pt,l1,l2)
	local dx,dy		= l2[1]-l1[1], l2[2]-l1[2]
	local length	= sqrt( dx*dx + dy*dy )
	dx,dy			= dx/length, dy/length
	local posOnLine = min(length, max(0,dx*(pt[1]-l1[1]) + dy*(pt[2]-l1[2])))
	return l1[1] + posOnLine * dx, l1[2] + posOnLine * dy
	end

function closestPointOnLine(pt,l1,l2)
	local dx,dy		= l2[1]-l1[1], l2[2]-l1[2]
	local length	= sqrt( dx*dx + dy*dy )
	dx,dy			= dx/length, dy/length
	local posOnLine = dx*(pt[1]-l1[1]) + dy*(pt[2]-l1[2])
	return l1[1] + posOnLine * dx, l1[2] + posOnLine * dy
	end
